import processing.pdf.*;

int[] xP = new int[1000000]; //x-position
int[] yP = new int[1000000]; //y-position
int[] cP = new int[1000000]; //command
int[] fN = new int[1000000]; //file number

int[] xStart= new int[100000]; // vectors in original .PLT
int[] yStart= new int[100000];
int[] xEnd= new int[100000];
int[] yEnd= new int[100000];

int[] xS2= new int[100000]; // vectors after cleaning double lines
int[] yS2= new int[100000];
int[] xE2= new int[100000];
int[] yE2= new int[100000];

int[] xS3= new int[100000]; // vectors after cleaning intermediate points
int[] yS3= new int[100000];
int[] xE3= new int[100000];
int[] yE3= new int[100000];

String[] ort = new String[1000];
String[] stadt = new String[1000];
String[] land = new String[1000];
String[] monat = new String[1000];
String[] jahr = new String[1000];
String[] farbe = new String[1000];
String[] motiv = new String[1000];

int oldX=0;
int oldY=0;

int lineIndex=0;
int fileNumber=0; // start
int fileIndex=0;
int emptyCount=0;

int pfn=0;
int margin=400;
int margins=140;
int linePos=1550;
int lineDist=58;
PFont f;

void setup() {
  size(1600, 2262, PDF, "vektordaten/vektorkollektor.pdf"); //1320
  f=createFont("Futura Md BT Medium.ttf", 40);
  textFont(f, 40);

  // load all metadata
  println("load meta");
  emptyCount=0;
  loadMeta();

  // generate optimized plt files
  println("optimize plt's");
  while (optimizePlt(fileIndex)) {
    // println("Optimized file#:"+fileIndex);
    fileIndex++;
  }

  // save raw data as .js
  println("save raw js");
  fileIndex=0;
  lineIndex=0;
  while (loadFileToArray(nf(fileIndex, 5)+".PLT")) {
    fileIndex++;
  }
  saveJs("vektorkollektor.js");

  
  // save optimized data as .js
  println("save optimized js");
  emptyCount=0;
  fileIndex=0;
  lineIndex=0;
  while (loadFileToArray("../vektordaten/optimizedPLT/"+nf(fileIndex, 5)+".PLT")) {
    fileIndex++;
  }
  saveJs("vektorkollektor_optimized.js");

  // generate pdf
  println("-------");
  println("generate pdf");
  emptyCount=0;
  fileIndex=0;
  lineIndex=0;
  while (pdfExport(fileIndex)) {
    fileIndex++;
    PGraphicsPDF pdf = (PGraphicsPDF) g;  
    pdf.nextPage();
  }


  PGraphicsPDF pdf = (PGraphicsPDF) g;  
  text("BILDER:", margins, linePos);
  text((fileIndex-emptyCount), margin, linePos);

  linePos+=lineDist;
  text("VEKTOREN: ", margins, linePos);
  text(lineIndex, margin, linePos);
  linePos+=lineDist;

  linePos+=lineDist;
  text("www.vektorkollektor.com ", margins, linePos);
}

void draw() {
  println("done");
  exit();
}




//////////////////
void loadMeta() {
  // metadata
  BufferedReader reader = createReader("data/VEKTORKOLLEKTOR _ Metadata _ 2021 - Sheet1.csv");
  String line = null;
  int lc=0;
  try {
    while ((line = reader.readLine()) != null) {
      lc++;
      String[] pieces = split(line, ",");

      //VEKTORNUMMER  ORT  STADT  LAND  MONAT  JAHR  STIFTFARBE  MOTIV
      for (int i=1; i<8; i++) {
        if (pieces[i].equals("")) {
          pieces[i]="-";
        }
      }
      ort[lc]   =pieces[1];
      stadt[lc] =pieces[2];
      land[lc]  =pieces[3];
      monat[lc] =pieces[4];
      jahr[lc]  =pieces[5];
      farbe[lc] =pieces[6];
      motiv[lc] =pieces[7];
    }
    reader.close();
  } 
  catch (IOException e) {
    e.printStackTrace();
  }
}
