////////////// ----------------------------------------- draw file

boolean pdfExport(int plotFileNumber) {
  
  margin=400;
  margins=140;
  linePos=1550;
  lineDist=58;
  
  String fileName=nf(plotFileNumber, 5)+".PLT";

  File f = dataFile(fileName);
  String filePath = f.getPath();
  boolean exist = f.isFile();

  if (exist) {

    background(255);
    strokeCap(SQUARE);
    noFill();
    stroke(0);
    strokeWeight(2);
    rect(140, 140, 220*6, 200*6);
    strokeWeight(5);


    BufferedReader reader = createReader("vektordaten/optimizedPLT/"+fileName);
    String line = null;
    int lineCount=0;

    try {
      while ((line = reader.readLine()) != null) {
        lineCount++;
        String[] pieces = split(line, ",");
        cP[lineIndex] = int(pieces[3]);
        if (cP[lineIndex]==1) {
          cP[lineIndex]=0;
        }
        if (cP[lineIndex]==255) {
          cP[lineIndex]=1;
        }
        xP[lineIndex] = int(pieces[1]);
        yP[lineIndex] = int(pieces[2]);
        fN[lineIndex] = plotFileNumber;

        if (cP[lineIndex]==1) {
          if (oldX==xP[lineIndex] && oldY==yP[lineIndex]) {
            xP[lineIndex]=constrain(xP[lineIndex]+1, 1, 220);
          }
          line(oldX*6+140, oldY*6+140, xP[lineIndex]*6+140, yP[lineIndex]*6+140);
        }

        oldX=xP[lineIndex];
        oldY=yP[lineIndex];

        if (int(pieces[0])!=3) { // skip calibration
          lineIndex++;
        }
      }
      if (lineCount<3) {
        emptyCount++;
        //println("pdf: "+emptyCount+"  empty:"+fileIndex);
      }
      reader.close();
      fill(0);
      text("INDEX:", margins, linePos);
      text(plotFileNumber, margin, linePos);

      linePos+=lineDist*2;
      text("ORT: ", margins, linePos);
      text(ort[plotFileNumber+2], margin, linePos);

      linePos+=lineDist;
      text(stadt[plotFileNumber+2]+" / "+land[plotFileNumber+2], margin, linePos);

      linePos+=lineDist;
      text("ZEIT:", margins, linePos);
      text(monat[plotFileNumber+2]+" / "+jahr[plotFileNumber+2], margin, linePos);
      linePos+=lineDist;
      text("STIFTFARBE: ", margins, linePos);
      text(farbe[plotFileNumber+2], margin, linePos);
      linePos+=lineDist;
      text("MOTIV:", margins, linePos);
      text(motiv[plotFileNumber+2], margin, linePos);
    } 
    catch (IOException e) {
      e.printStackTrace();
    }

    if (lineCount<10) {
      int toggle=0;
      cP[lineIndex]=  0;//toggle;
      xP[lineIndex] = 2;
      yP[lineIndex] = 100;
      fN[lineIndex] = pfn;
      lineIndex++;
      for (int i=1; i<10; i++) {
        cP[lineIndex]=  1;
        xP[lineIndex] = 2;
        yP[lineIndex] = 100;
        fN[lineIndex] = pfn;
        lineIndex++;
      }
      for (int i=2; i<218; i+=2) {
        if (toggle==0) {
          toggle=1;
        } else {
          toggle=0;
        }
        cP[lineIndex]=  toggle;
        xP[lineIndex] = i;
        yP[lineIndex] = 100-toggle*2;
        fN[lineIndex] = pfn;
        lineIndex++;
      }
      cP[lineIndex]=  0; 
      xP[lineIndex] = 218;
      yP[lineIndex] = 100;
      fN[lineIndex] = pfn;
      lineIndex++;
    }
  }
  return (exist);
}
