import processing.core.*; 
import processing.data.*; 
import processing.event.*; 
import processing.opengl.*; 

import processing.pdf.*; 

import java.util.HashMap; 
import java.util.ArrayList; 
import java.io.File; 
import java.io.BufferedReader; 
import java.io.PrintWriter; 
import java.io.InputStream; 
import java.io.OutputStream; 
import java.io.IOException; 

public class PLT_process_06 extends PApplet {



int[] xP = new int[1000000]; //x-position
int[] yP = new int[1000000]; //y-position
int[] cP = new int[1000000]; //command
int[] fN = new int[1000000]; //file number

int[] xStart= new int[100000]; // vectors in original .PLT
int[] yStart= new int[100000];
int[] xEnd= new int[100000];
int[] yEnd= new int[100000];

int[] xS2= new int[100000]; // vectors after cleaning double lines
int[] yS2= new int[100000];
int[] xE2= new int[100000];
int[] yE2= new int[100000];

int[] xS3= new int[100000]; // vectors after cleaning intermediate points
int[] yS3= new int[100000];
int[] xE3= new int[100000];
int[] yE3= new int[100000];

String[] ort = new String[1000];
String[] stadt = new String[1000];
String[] land = new String[1000];
String[] monat = new String[1000];
String[] jahr = new String[1000];
String[] farbe = new String[1000];
String[] motiv = new String[1000];

int oldX=0;
int oldY=0;

int lineIndex=0;
int fileNumber=0; // start
int fileIndex=0;
int emptyCount=0;

int pfn=0;
int margin=400;
int margins=140;
int linePos=1550;
int lineDist=58;
PFont f;

public void setup() {
   //1320
  f=createFont("Futura Md BT Medium.ttf", 40);
  textFont(f, 40);

  // load all metadata
  println("load meta");
  emptyCount=0;
  loadMeta();

  // generate optimized plt files
  println("optimize plt's");
  while (optimizePlt(fileIndex)) {
    // println("Optimized file#:"+fileIndex);
    fileIndex++;
  }

  // save raw data as .js
  println("save raw js");
  fileIndex=0;
  lineIndex=0;
  while (loadFileToArray(nf(fileIndex, 5)+".PLT")) {
    fileIndex++;
  }
  saveJs("vektorkollektor.js");

  
  // save optimized data as .js
  println("save optimized js");
  emptyCount=0;
  fileIndex=0;
  lineIndex=0;
  while (loadFileToArray("../vektordaten/optimizedPLT/"+nf(fileIndex, 5)+".PLT")) {
    fileIndex++;
  }
  saveJs("vektorkollektor_optimized.js");

  // generate pdf
  println("-------");
  println("generate pdf");
  emptyCount=0;
  fileIndex=0;
  lineIndex=0;
  while (pdfExport(fileIndex)) {
    fileIndex++;
    PGraphicsPDF pdf = (PGraphicsPDF) g;  
    pdf.nextPage();
  }


  PGraphicsPDF pdf = (PGraphicsPDF) g;  
  text("BILDER:", margins, linePos);
  text((fileIndex-emptyCount), margin, linePos);

  linePos+=lineDist;
  text("VEKTOREN: ", margins, linePos);
  text(lineIndex, margin, linePos);
  linePos+=lineDist;

  linePos+=lineDist;
  text("www.vektorkollektor.com ", margins, linePos);
}

public void draw() {
  println("done");
  exit();
}




//////////////////
public void loadMeta() {
  // metadata
  BufferedReader reader = createReader("data/VEKTORKOLLEKTOR _ Metadata _ 2021 - Sheet1.csv");
  String line = null;
  int lc=0;
  try {
    while ((line = reader.readLine()) != null) {
      lc++;
      String[] pieces = split(line, ",");

      //VEKTORNUMMER  ORT  STADT  LAND  MONAT  JAHR  STIFTFARBE  MOTIV
      for (int i=1; i<8; i++) {
        if (pieces[i].equals("")) {
          pieces[i]="-";
        }
      }
      ort[lc]   =pieces[1];
      stadt[lc] =pieces[2];
      land[lc]  =pieces[3];
      monat[lc] =pieces[4];
      jahr[lc]  =pieces[5];
      farbe[lc] =pieces[6];
      motiv[lc] =pieces[7];
    }
    reader.close();
  } 
  catch (IOException e) {
    e.printStackTrace();
  }
}
public boolean loadFileToArray(String fileName) {
  int plotFileNumber=fileIndex;
  File f = dataFile(fileName);
  String filePath = f.getPath();
  boolean exist = f.isFile();

  if (exist) {

    BufferedReader reader = createReader(fileName);
    String line = null;
    int lineCount=0;

    try {
      while ((line = reader.readLine()) != null) {
        lineCount++;
        String[] pieces = split(line, ",");
        cP[lineIndex] = PApplet.parseInt(pieces[3]);
        if (cP[lineIndex]==1) {
          cP[lineIndex]=0;
        }
        if (cP[lineIndex]==255) {
          cP[lineIndex]=1;
        }
        xP[lineIndex] = PApplet.parseInt(pieces[1]);
        yP[lineIndex] = PApplet.parseInt(pieces[2]);
        fN[lineIndex] = plotFileNumber;
        pfn=fN[lineIndex];

        if (cP[lineIndex]==1) {
          if (oldX==xP[lineIndex] && oldY==yP[lineIndex]) {
            xP[lineIndex]=constrain(xP[lineIndex]+1, 1, 220);
          }
        }

        oldX=xP[lineIndex];
        oldY=yP[lineIndex];

        if (PApplet.parseInt(pieces[0])!=3) { // skip calibration
          lineIndex++;
        }
      }
      if (lineCount<3) {
        emptyCount++;
        //println("lf2a: "+emptyCount+"  empty:"+fileIndex);
      }
      reader.close();
      
    } 
    catch (IOException e) {
      e.printStackTrace();
    }

    if (lineCount<10) {
      int toggle=1;
     /* cP[lineIndex]=  0;//toggle;
      xP[lineIndex] = 2;
      yP[lineIndex] = 100;
      fN[lineIndex] = pfn;
      lineIndex++;
      for (int i=1; i<10; i++) {
        cP[lineIndex]=  1;
        xP[lineIndex] = 2;
        yP[lineIndex] = 100;
        fN[lineIndex] = pfn;
        lineIndex++;
      }*/
      for (int i=20; i<200; i+=4) {
        if (toggle==0) {
          toggle=1;
        } else {
          toggle=0;
        }
        cP[lineIndex]=  toggle;
        xP[lineIndex] = i;
        yP[lineIndex] = 100;
        fN[lineIndex] = pfn;
        lineIndex++;
      }
      cP[lineIndex]=  0; 
      xP[lineIndex] = 218;
      yP[lineIndex] = 100;
      fN[lineIndex] = pfn;
      lineIndex++;
    }
  }
  return (exist);
}
public boolean optimizePlt(int plotFileNumber) {
  String fileName=nf(plotFileNumber, 5)+".PLT";

  File f = dataFile(fileName);
  String filePath = f.getPath();
  boolean exist = f.isFile();

  if (exist) {

    /// ----------------------------------------- load all vectors from .PLT file into array

    BufferedReader reader = createReader("data/"+fileName);
    String line = null;
    int vectorCount=0;

    xStart[vectorCount]=1;
    yStart[vectorCount]=1;

    try {
      while ((line = reader.readLine()) != null) {
        String[] pieces = split(line, ",");
        if (PApplet.parseInt(pieces[3])==1) {
          xStart[vectorCount]=PApplet.parseInt(pieces[1]);
          yStart[vectorCount]=PApplet.parseInt(pieces[2]);
        }
        if (PApplet.parseInt(pieces[3])==255) {
          xEnd[vectorCount]=PApplet.parseInt(pieces[1]);
          yEnd[vectorCount]=PApplet.parseInt(pieces[2]);
          vectorCount++;
          xStart[vectorCount]=PApplet.parseInt(pieces[1]);
          yStart[vectorCount]=PApplet.parseInt(pieces[2]);
        }
      }

      reader.close();
    } 
    catch (IOException e) {
      e.printStackTrace();
    }

    /// ----------------------------------------- find and remove double vectors

    int v2Count=0;

    for (int i=0; i<vectorCount; i++) {
      boolean doubleVector=false;
      for (int k=0; k<i; k++) {
        if (
          (xStart[i]==xStart[k] && yStart[i]==yStart[k] && xEnd[i]==xEnd[k] && yEnd[i]==yEnd[k])
          ||
          (xStart[i]==xEnd[k] && yStart[i]==yEnd[k] && xEnd[i]==xStart[k] && yEnd[i]==yStart[k])
          ) {
          doubleVector=true;
        }
      }
      if (!doubleVector) {
        xS2[v2Count]=xStart[i];
        yS2[v2Count]=yStart[i];
        xE2[v2Count]=xEnd[i];
        yE2[v2Count]=yEnd[i];
        v2Count++;
      }
    }

    /// ----------------------------------------- delete intermediate points

    int v3Count=0;

    xS3[0]=xS2[0];
    yS3[0]=yS2[0];
    xE3[0]=xE2[0];
    yE3[0]=yE2[0];
    for (int i=1; i<v2Count; i++) {
      if (
        ((xS2[i-1]-xE2[i-1] == xS2[i]-xE2[i]) && (yS2[i-1]-yE2[i-1] == yS2[i]-yE2[i]))
        &&
        (xE2[i-1]==xS2[i] && yE2[i-1]==yS2[i])
        ) {
        // vector has same direction and last vector ends where new vector starts: set new endpoint
        xE3[v3Count]=xE2[i];
        yE3[v3Count]=yE2[i];
      } else {
        // vector has different direction: set new start & endpoint
        v3Count++;
        xS3[v3Count]=xS2[i];
        yS3[v3Count]=yS2[i];
        xE3[v3Count]=xE2[i];
        yE3[v3Count]=yE2[i];
      }
    }

    /// ----------------------------------------- write optimized .PLT file

    PrintWriter output;
    output = createWriter("vektordaten/optimizedPLT/"+fileName);
    for (int i=0; i<=v3Count; i++) {

      output.println("2,"+xS3[i]+","+yS3[i]+",1"); // Write the coordinate to the file
      output.println("2,"+xE3[i]+","+yE3[i]+",255");
    }
    output.flush(); // write the data to the file
    output.close(); // finish the file


   // println("-------");
   // println("orig:"+vectorCount+" clean:"+v2Count+" optimized:"+v3Count);
  }
  return (exist);
}
////////////// ----------------------------------------- draw file

public boolean pdfExport(int plotFileNumber) {
  
  margin=400;
  margins=140;
  linePos=1550;
  lineDist=58;
  
  String fileName=nf(plotFileNumber, 5)+".PLT";

  File f = dataFile(fileName);
  String filePath = f.getPath();
  boolean exist = f.isFile();

  if (exist) {

    background(255);
    strokeCap(SQUARE);
    noFill();
    stroke(0);
    strokeWeight(2);
    rect(140, 140, 220*6, 200*6);
    strokeWeight(5);


    BufferedReader reader = createReader("vektordaten/optimizedPLT/"+fileName);
    String line = null;
    int lineCount=0;

    try {
      while ((line = reader.readLine()) != null) {
        lineCount++;
        String[] pieces = split(line, ",");
        cP[lineIndex] = PApplet.parseInt(pieces[3]);
        if (cP[lineIndex]==1) {
          cP[lineIndex]=0;
        }
        if (cP[lineIndex]==255) {
          cP[lineIndex]=1;
        }
        xP[lineIndex] = PApplet.parseInt(pieces[1]);
        yP[lineIndex] = PApplet.parseInt(pieces[2]);
        fN[lineIndex] = plotFileNumber;

        if (cP[lineIndex]==1) {
          if (oldX==xP[lineIndex] && oldY==yP[lineIndex]) {
            xP[lineIndex]=constrain(xP[lineIndex]+1, 1, 220);
          }
          line(oldX*6+140, oldY*6+140, xP[lineIndex]*6+140, yP[lineIndex]*6+140);
        }

        oldX=xP[lineIndex];
        oldY=yP[lineIndex];

        if (PApplet.parseInt(pieces[0])!=3) { // skip calibration
          lineIndex++;
        }
      }
      if (lineCount<3) {
        emptyCount++;
        //println("pdf: "+emptyCount+"  empty:"+fileIndex);
      }
      reader.close();
      fill(0);
      text("INDEX:", margins, linePos);
      text(plotFileNumber, margin, linePos);

      linePos+=lineDist*2;
      text("ORT: ", margins, linePos);
      text(ort[plotFileNumber+2], margin, linePos);

      linePos+=lineDist;
      text(stadt[plotFileNumber+2]+" / "+land[plotFileNumber+2], margin, linePos);

      linePos+=lineDist;
      text("ZEIT:", margins, linePos);
      text(monat[plotFileNumber+2]+" / "+jahr[plotFileNumber+2], margin, linePos);
      linePos+=lineDist;
      text("STIFTFARBE: ", margins, linePos);
      text(farbe[plotFileNumber+2], margin, linePos);
      linePos+=lineDist;
      text("MOTIV:", margins, linePos);
      text(motiv[plotFileNumber+2], margin, linePos);
    } 
    catch (IOException e) {
      e.printStackTrace();
    }

    if (lineCount<10) {
      int toggle=0;
      cP[lineIndex]=  0;//toggle;
      xP[lineIndex] = 2;
      yP[lineIndex] = 100;
      fN[lineIndex] = pfn;
      lineIndex++;
      for (int i=1; i<10; i++) {
        cP[lineIndex]=  1;
        xP[lineIndex] = 2;
        yP[lineIndex] = 100;
        fN[lineIndex] = pfn;
        lineIndex++;
      }
      for (int i=2; i<218; i+=2) {
        if (toggle==0) {
          toggle=1;
        } else {
          toggle=0;
        }
        cP[lineIndex]=  toggle;
        xP[lineIndex] = i;
        yP[lineIndex] = 100-toggle*2;
        fN[lineIndex] = pfn;
        lineIndex++;
      }
      cP[lineIndex]=  0; 
      xP[lineIndex] = 218;
      yP[lineIndex] = 100;
      fN[lineIndex] = pfn;
      lineIndex++;
    }
  }
  return (exist);
}

public void saveJs(String fileName) { // save plt's as js

  PrintWriter output;
  println("exporting: "+fileName);

  output = createWriter("vektordaten/"+fileName); 

  output.println("/***");
  output.println("*     ___      ___ _______   ___  __    _________  ________  ________  ___  __    ________  ___       ___       _______   ___  __    _________  ________  ________     ");
  output.println("*    |\\  \\    /  /|\\  ___ \\ |\\  \\|\\  \\ |\\___   ___\\\\   __  \\|\\   __  \\|\\  \\|\\  \\ |\\   __  \\|\\  \\     |\\  \\     |\\  ___ \\ |\\  \\|\\  \\ |\\___   ___\\\\   __  \\|\\   __  \\    ");
  output.println("*    \\ \\  \\  /  / | \\   __/|\\ \\  \\/  /|\\|___ \\  \\_\\ \\  \\|\\  \\ \\  \\|\\  \\ \\  \\/  /|\\ \\  \\|\\  \\ \\  \\    \\ \\  \\    \\ \\   __/|\\ \\  \\/  /|\\|___ \\  \\_\\ \\  \\|\\  \\ \\  \\|\\  \\   ");
  output.println("*     \\ \\  \\/  / / \\ \\  \\_|/_\\ \\   ___  \\   \\ \\  \\ \\ \\  \\\\\\  \\ \\   _  _\\ \\   ___  \\ \\  \\\\\\  \\ \\  \\    \\ \\  \\    \\ \\  \\_|/_\\ \\   ___  \\   \\ \\  \\ \\ \\  \\\\\\  \\ \\   _  _\\  ");
  output.println("*      \\ \\    / /   \\ \\  \\_|\\ \\ \\  \\\\ \\  \\   \\ \\  \\ \\ \\  \\\\\\  \\ \\  \\\\  \\\\ \\  \\\\ \\  \\ \\  \\\\\\  \\ \\  \\____\\ \\  \\____\\ \\  \\_|\\ \\ \\  \\\\ \\  \\   \\ \\  \\ \\ \\  \\\\\\  \\ \\  \\\\  \\| ");
  output.println("*       \\ \\__/ /     \\ \\_______\\ \\__\\\\ \\__\\   \\ \\__\\ \\ \\_______\\ \\__\\\\ _\\\\ \\__\\\\ \\__\\ \\_______\\ \\_______\\ \\_______\\ \\_______\\ \\__\\\\ \\__\\   \\ \\__\\ \\ \\_______\\ \\__\\\\ _\\ ");
  output.println("*        \\|__|/       \\|_______|\\|__| \\|__|    \\|__|  \\|_______|\\|__|\\|__|\\|__| \\|__|\\|_______|\\|_______|\\|_______|\\|_______|\\|__| \\|__|    \\|__|  \\|_______|\\|__|\\|__|");
  output.println("*");                                                                                                                                                                      
  output.println("*");
  output.println("*       This file contains a list of vector drawings in the form of coordinates.");
  output.println("*        The vectors were collected by Kati Hyyppa [http://katihyyppa.com] & Niklas Roy [https://niklasroy.com] with the VEKTORKOLLEKTOR [http://vektorkollektor.com].");
  output.println("*         Legend: xP[] = x-coordinate // yP[] = y-coordinate // cP[] = draw // fN[] = original vektorkollektor .PLT file number");                                                                                                                                                                      
  output.println("*");

  if (fileName=="vektorkollektor_optimized.js")
  {
    output.println("*           This is an OPTIMIZED DATASET: Double lines and intermediate coordinates in straight lines are deleted.");
    output.println("*");
    output.println("*             The content of this file is in the PUBLIC DOMAIN / License: CC0");                                                                                                                                                                      
    output.println("*/");
  } else {
    output.println("*           The content of this file is in the PUBLIC DOMAIN / License: CC0");                                                                                                                                                                      
    output.println("*/");
  }






  output.print("var xP = [");
  for (int i=0; i<lineIndex; i++) {  
    output.print(xP[i]+","); // Write the x-coordinate to the js array
  }
  output.println(xP[lineIndex]+"];");

  output.print("var yP = [");
  for (int i=0; i<lineIndex; i++) {  
    output.print(yP[i]+","); // Write the y-coordinate to the js array
  }
  output.println(yP[lineIndex]+"];");

  output.print("var cP = [");
  for (int i=0; i<lineIndex; i++) {  
    output.print(cP[i]+","); // Write the command to the js array
  }
  output.println(cP[lineIndex]+"];");

  output.print("var fN = [");
  for (int i=0; i<lineIndex; i++) {  
    output.print(fN[i]+","); // Write the plot file number to the js array
  }
  output.println(fN[lineIndex]+"];");

  output.flush();  
  output.close();
}
  public void settings() {  size(1600, 2262, PDF, "vektordaten/vektorkollektor.pdf"); }
  static public void main(String[] passedArgs) {
    String[] appletArgs = new String[] { "--present", "--window-color=#333333", "--stop-color=#cccccc", "PLT_process_06" };
    if (passedArgs != null) {
      PApplet.main(concat(appletArgs, passedArgs));
    } else {
      PApplet.main(appletArgs);
    }
  }
}
